// Set this to false if you want to manually set you hostname & port
var use_default_host=true; 

// Manually set the host name (only used if use_default_host is set to false)
// Make sure you set the correct port if you are configuring manually    
var ip_address = "192.168.124.23";

//  Manually set the port # (Warning: Normally should be 80, but may need 
//  to be different if another application, such as skype, interferes with 
//  your HTTP server)
var port="8080";	

//Decide what IP address to bind to
if (port== "") port = "80";
var baseURL = "http://" + ip_address + ":" + port + "/xmlget?";

if (use_default_host)
{
	baseURL = "http://" + location.host + "/xmlget?";
}

var current_cuelist = 1;


// Update the data on screen via AJAX(only if it has changed)
var lastlisthtml="";
var lastqhtml = "";
function updatestatus(){

  var listhtml;
  var atstring = "<cuelist " + current_cuelist + " name>";
  listhtml = getAutoText(atstring);
  if (listhtml == ""){
	current_cuelist--;
	updatestatus();
  }
  if (lastlisthtml != listhtml){
    document.getElementById("qlistname").innerHTML= listhtml;
	lastlisthtml = listhtml;
  }
    
  var qhtml;
  atstring = "<cuelist " + current_cuelist + " current>";
  qhtml = getAutoText(atstring);
  if (qhtml=="") { qhtml="--"};
  if (qhtml != lastqhtml){
	document.getElementById("qname").innerHTML=qhtml;
	lastqhtml = qhtml;
  }
  
  setTimeout("updatestatus()", 1000);
}

// Returns an autotext command from the server
function getAutoText(autotext){
  url = baseURL + "AutoText=" + autotext;
  var response = sendcommand(url);
  return (parseXML(response));
}

// Play specified cuelist
function pressplay(ql){
  url = baseURL+"ExecCommand=StartCuelist(QL(" + ql + "));"
  sendcommand(url);
  updatestatus();
}

// Select the next cuelist
function nextcuelist(){
	++current_cuelist;
	
	updatestatus();
}

// Select the previous cuelist 
function prevcuelist(){
	--current_cuelist;
	if (current_cuelist < 1) current_cuelist = 1;
	updatestatus();
}


// Stop the specified cuelist
function stop(ql){
  url = baseURL+"ExecCommand=StopCuelist(QL(" + ql + "));"
  sendcommand(url);
  updatestatus();
}

// Release all cuelists
function stopAll(){
  url = baseURL+"ExecCommand=ReleaseAll();"
  sendcommand(url);
  updatestatus();
}

function GetXmlHttpObject()
{
var xmlHttp=null;
try
  {
  // Firefox, Opera 8.0+, Safari
  xmlHttp=new XMLHttpRequest();
  }
catch (e)
  {
  // Internet Explorer
  try
    {
    xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
    }
  catch (e)
    {
    xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
  }
return xmlHttp;
}

// Sends a command to the e:cue 5.0 software  
// returns XML data sent from the server      
function sendcommand(url)
{
  xmlHttp=GetXmlHttpObject();
  if (xmlHttp==null)
    {
    alert ("Your browser does not support AJAX!"); 
    return;
    } 
  //xmlHttp.onreadystatechange=stateChanged;
  xmlHttp.open("GET",url,false);
  xmlHttp.send(null);
  return xmlHttp.responseText;
} 

function parseXML(text)
{
  var xmlDoc;

  try //Internet Explorer
    {
    xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
    xmlDoc.async="false";
    xmlDoc.loadXML(text);
    }
  catch(e)
    {
    try //Firefox, Mozilla, Opera, etc.
    {
    parser=new DOMParser();
    xmlDoc=parser.parseFromString(text,"text/xml");
    }
    catch(e)
    {
    alert(e.message);
    return;
    }
  }
  var result =  xmlDoc.getElementsByTagName("result_entry")[0].getAttribute('value');
  return result;
}

// Continually update visible info on screen
setTimeout("updatestatus()", 0);
